Index: orxonox/branches/levelloader/src/world_entities/skysphere.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/skysphere.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/skysphere.cc	(revision 3605)
@@ -24,4 +24,6 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
 #include "material.h"
 #include "skysphere.h"
@@ -29,5 +31,4 @@
 #include "vector.h"
 #include "world_entity.h"
-
 
 using namespace std;
@@ -38,6 +39,7 @@
 Skysphere::Skysphere()
 {  
-  initialize("../data/pictures/sky-replace.jpg");
+  this->initialize("../data/pictures/sky-replace.jpg");
 }
+
 
 /**
@@ -47,6 +49,7 @@
 Skysphere::Skysphere(char* fileName)
 {
-  initialize(fileName);
+  this->initialize(fileName);
 }
+
 
 /**
@@ -56,6 +59,6 @@
 {
   PRINTF(3)("Deleting the SkySphere\n");
-  delete skyMaterial;
-  free(sphereObj);
+  delete this->skyMaterial;
+  free(this->sphereObj);
 }
 
@@ -69,5 +72,5 @@
   this->sphereObj = gluNewQuadric();
   gluQuadricTexture(this->sphereObj, GL_TRUE);
-  this->setRadius(250.0);
+  this->setRadius(1900.0);
 
   this->skyMaterial = new Material("Sky");
@@ -75,14 +78,4 @@
   this->skyMaterial->setIllum(3);
   this->skyMaterial->setAmbient(1.0, 1.0, 1.0);
-}
-
-
-/**
-   \brief sets the Radius of the Sphere.
-   \param radius The Radius of The Sphere
-*/
-void Skysphere::setRadius(float radius)
-{
-  this->sphereRadius = radius;
 }
 
@@ -99,16 +92,4 @@
 
 /**
-   \brief updates the position of the Skysphere
-   \param sphereCenter The coordinate of the Center of the Sphere
-   
-   This is normally done in the update-phase of world, so the Skysphere is always centered at the Camera.
-*/
-void Skysphere::updatePosition(Vector sphereCenter)
-{
-  this->sphereCenter = sphereCenter;
-}
-
-
-/**
    \brief draws the Skysphere
    
@@ -117,15 +98,26 @@
 void Skysphere::draw()
 {
-  glEnable(GL_TEXTURE_2D);
+  glPushMatrix();
+  glMatrixMode(GL_MODELVIEW);
+  glTranslatef(this->absCoordinate.x,
+	       this->absCoordinate.y,
+	       this->absCoordinate.z);
+
+  //glRotatef(-30, 1, 0, 0);
+  //glRotatef(95.0f, 0.0f, 0.0f, 1.0f);
+  //glRotatef(-250.0f, 0.0, 1.0f, 0.0f);
+  
   skyMaterial->select();
-  glPushMatrix();
-  glTranslatef(this->sphereCenter.x,this->sphereCenter.y,this->sphereCenter.z);
-  
-  glRotatef(-30, 1, 0, 0);
-  glRotatef(95.0f, 0.0f, 0.0f, 1.0f);
-  glRotatef(-250.0f, 0.0, 1.0f, 0.0f);
-  
-  gluSphere(sphereObj, sphereRadius, 20, 20);
+  gluSphere(this->sphereObj, this->sphereRadius, 20, 20);
   glPopMatrix();
-  glDisable(GL_TEXTURE_2D);
 }
+
+
+/**
+   \brief sets the Radius of the Sphere.
+   \param radius The Radius of The Sphere
+*/
+void Skysphere::setRadius(float radius)
+{
+  this->sphereRadius = radius;
+}
Index: orxonox/branches/levelloader/src/world_entities/skysphere.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/skysphere.h	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/skysphere.h	(revision 3605)
@@ -15,4 +15,5 @@
 /* INCLUDES */
 #include "p_node.h"
+#include "world_entity.h"
 
 /* FORWARD DEFINITION */
@@ -21,5 +22,5 @@
 
 //! A Class to handle a SkySphere
-class Skysphere : public PNode 
+class Skysphere : public WorldEntity
 {
 
@@ -27,19 +28,17 @@
   Skysphere();
   Skysphere(char* fileName);
-  ~Skysphere();
+  virtual ~Skysphere();
+  void destroy();
 
   void setRadius(float radius);
   void setTexture(char* fileName);
 
-  void updatePosition(Vector sphereCenter);
-  void draw();
+  virtual void draw();
 
  private: 
   GLUquadricObj *sphereObj; //!< A Placeholder for the SkySphere.
   Material *skyMaterial;    //!< A Material for the SkySphere.
-  Vector sphereCenter;      //!< Center of the SkySphere.
   float sphereRadius;       //!< Radius of the SkySphere. This should match the frustum maximum range.
-
-
+    
   void initialize(char* fileName);  
 };
Index: orxonox/branches/levelloader/src/world_entities/terrain.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/terrain.cc	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/terrain.cc	(revision 3605)
@@ -0,0 +1,271 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+
+#include "terrain.h"
+
+#include "glincl.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+
+*/
+Terrain::Terrain () 
+{
+  this->init();
+}
+
+/**
+   \brief Constructor for loading a Terrain out of a file
+   \param fileName The file to load data from.
+ 
+   this either loads out of an OBJ-file, or loads a heightmap if no .obj-extension is found.
+*/
+Terrain::Terrain(char* fileName)
+{
+  this->init();
+
+  if (strstr(fileName, ".obj") || strstr(fileName, ".OBJ"))
+    {
+      this->model = (OBJModel*)new OBJModel(fileName);
+    }
+  else
+    {
+      // load the hightMap here.
+    }
+}
+
+/**
+   \brief a Constructor for the Debug-Worlds
+
+   \todo make it not compileable when not in debug-mode
+*/
+Terrain::Terrain(DebugTerrain debugTerrain)
+{
+  this->init();
+  this->buildDebugTerrain(debugTerrain);
+}
+
+/**
+   \brief standard deconstructor
+
+*/
+Terrain::~Terrain () 
+{
+  if (objectList)
+    glDeleteLists(this->objectList, 1);
+}
+
+
+void Terrain::init(void)
+{
+   this->setClassName ("Terrain");
+
+   this->objectList = 0;
+}
+
+
+
+void Terrain::draw ()
+{ 
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  float matrix[4][4];
+  
+  /* translate */
+  glTranslatef (this->getAbsCoor ().x, 
+		this->getAbsCoor ().y, 
+		this->getAbsCoor ().z);
+  /* rotate */
+  this->getAbsDir ().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+
+  if (objectList)
+    glCallList(objectList);
+  else if (model)
+    model->draw();
+  //  this->model->draw();
+  glPopMatrix();
+}
+
+
+void Terrain::buildDebugTerrain(DebugTerrain debugTerrain)
+{
+  // if the terrain is the Terrain of Dave
+  if (debugTerrain == TERRAIN_DAVE)
+    {
+      objectList = glGenLists(1);
+      glNewList (objectList, GL_COMPILE);
+      
+      glColor3f(1.0,0,0);
+      
+      int sizeX = 100;
+      int sizeZ = 80;
+      float length = 1000;
+      float width = 200;
+      float widthX = float (length /sizeX);
+      float widthZ = float (width /sizeZ);
+      
+      float height [sizeX][sizeZ];
+      Vector normal_vectors[sizeX][sizeZ];
+      
+      
+      for ( int i = 0; i<sizeX-1; i+=1)
+	for (int j = 0; j<sizeZ-1;j+=1)
+	  //height[i][j] = rand()/20046 + (j-25)*(j-25)/30;
+#ifdef __WIN32__
+	  height[i][j]=(sin((float)j/3)*rand()*i/182400)*.5;
+#else
+      height[i][j]=(sin((float)j/3)*rand()*(long)i/6282450500.0)*.5;
+#endif
+      
+      //Die Huegel ein wenig glaetten
+      for (int h=1; h<2;h++)
+	for (int i=1;i<sizeX-2 ;i+=1 )
+	  for(int j=1;j<sizeZ-2;j+=1)
+	    height[i][j]=(height[i+1][j]+height[i][j+1]+height[i-1][j]+height[i][j-1])/4;
+      
+      //Berechnung von normalen Vektoren
+      for(int i=1;i<sizeX-2;i+=1)
+	for(int j=1;j<sizeZ-2 ;j+=1)
+	  {
+	    Vector v1 = Vector (widthX*(1),      height[i][j],      widthZ*(j) );
+	    Vector v2 = Vector (widthX*(i-1),    height[i-1][j],    widthZ*(j));
+	    Vector v3 = Vector (widthX*(i),      height[i][j+1],    widthZ*(j+1));
+	    Vector v4 = Vector (widthX*(i+1),    height[i+1][j],    widthZ*(j));
+	    Vector v5 = Vector (widthX*(i),      height[i][j-1],    widthZ*(j-1));
+	    
+	    Vector c1 = v2 - v1;
+	    Vector c2 = v3 - v1;
+	    Vector c3=  v4 - v1;
+	    Vector c4 = v5 - v1;
+	    Vector zero = Vector (0,0,0);
+	    normal_vectors[i][j]=c1.cross(v3-v5)+c2.cross(v4-v2)+c3.cross(v5-v3)+c4.cross(v2-v4);
+	    normal_vectors[i][j].normalize();
+	  }
+      
+      glBegin(GL_QUADS);
+      int snowheight=3;
+      for ( int i = 0; i<sizeX; i+=1)
+	for (int j = 0; j<sizeZ;j+=1)
+	  {	  
+	    Vector v1 = Vector (widthX*(i),      height[i][j]-20,       widthZ*(j)  -width/2);
+	    Vector v2 = Vector (widthX*(i+1),    height[i+1][j]-20,     widthZ*(j)  -width/2);
+	    Vector v3 = Vector (widthX*(i+1),    height[i+1][j+1]-20,   widthZ*(j+1)-width/2);
+	    Vector v4 = Vector (widthX*(i),      height[i][j+1]-20,     widthZ*(j+1)-width/2);
+	    float a[3];
+	    if(height[i][j]<snowheight){
+	      a[0]=0;
+	      a[1]=1.0-height[i][j]/10-.3;
+	      a[2]=0;
+	      glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	    }
+	    else{
+	      a[0]=1.0;
+	      a[1]=1.0;
+	      a[2]=1.0;
+	      glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	      
+	    }
+	    glNormal3f(normal_vectors[i][j].x, normal_vectors[i][j].y, normal_vectors[i][j].z);
+	    glVertex3f(v1.x, v1.y, v1.z);
+	    if(height[i+1][j]<snowheight){
+	      a[0]=0;
+	      a[1] =1.0-height[i+1][j]/10-.3;
+	      a[2]=0;
+	      glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	    }
+	    else{
+	      a[0]=1.0;
+	      a[1]=1.0;
+	      a[2]=1.0;
+	      glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	      
+	    }
+	    glNormal3f(normal_vectors[i+1][j].x, normal_vectors[i+1][j].y, normal_vectors[i+1][j].z);
+	    glVertex3f(v2.x, v2.y, v2.z);
+	    if(height[i+1][j+1]<snowheight){
+	      a[0]=0;
+	      a[1] =1.0-height[i+1][j+1]/10-.3;
+	      a[2]=0;
+	      glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	    }
+	    else{
+	      a[0]=1.0;
+	      a[1]=1.0;
+	      a[2]=1.0;
+	      glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	      
+	      
+	    }
+	    glNormal3f(normal_vectors[i+1][j+1].x, normal_vectors[i+1][j+1].y, normal_vectors[i+1][j+1].z);
+	    glVertex3f(v3.x, v3.y, v3.z);
+	    if(height[i][j+1]<snowheight){
+	      a[0]=0;
+	      a[1] =1.0-height[i+1][j+1]/10-.3;
+	      a[2]=0;
+	      glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	    }
+	    else{
+	      a[0]=1.0;
+	      a[1]=1.0;
+	      a[2]=1.0;
+	      glMaterialfv(GL_FRONT,GL_DIFFUSE,a);
+	    }
+	    glNormal3f(normal_vectors[i][j+1].x, normal_vectors[i][j+1].y, normal_vectors[i][j+1].z);
+	    glVertex3f(v4.x, v4.y, v4.z);
+	    
+	  }
+      glEnd();
+      glEndList();
+    }
+
+  if (debugTerrain == TERRAIN_BENSCH)
+    {
+      /*
+	this->model = (OBJModel*) new Model();
+      this->model->setName("CUBE");
+      this->model->addVertex (-0.5, -0.5, 0.5);
+      this->model->addVertex (0.5, -0.5, 0.5);
+      this->model->addVertex (-0.5, 0.5, 0.5);
+      this->model->addVertex (0.5, 0.5, 0.5);
+      this->model->addVertex (-0.5, 0.5, -0.5);
+      this->model->addVertex (0.5, 0.5, -0.5);
+      this->model->addVertex (-0.5, -0.5, -0.5);
+      this->model->addVertex (0.5, -0.5, -0.5);
+      
+      this->model->addVertexTexture (0.0, 0.0);
+      this->model->addVertexTexture (1.0, 0.0);
+      this->model->addVertexTexture (0.0, 1.0);
+      this->model->addVertexTexture (1.0, 1.0);
+      this->model->addVertexTexture (0.0, 2.0);
+      this->model->addVertexTexture (1.0, 2.0);
+      this->model->addVertexTexture (0.0, 3.0);
+      this->model->addVertexTexture (1.0, 3.0);
+      this->model->addVertexTexture (0.0, 4.0);
+      this->model->addVertexTexture (1.0, 4.0);
+      this->model->addVertexTexture (2.0, 0.0);
+      this->model->addVertexTexture (2.0, 1.0);
+      this->model->addVertexTexture (-1.0, 0.0);
+      this->model->addVertexTexture (-1.0, 1.0);
+
+      this->model->finalize();
+      */
+    }
+  
+}
Index: orxonox/branches/levelloader/src/world_entities/terrain.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/terrain.h	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/terrain.h	(revision 3605)
@@ -0,0 +1,39 @@
+/*! 
+    \file terrain.h
+    \brief Defines and handles the terrain of the World
+
+    \todo implement it
+
+    The terrain should either be build from a Model a OBJModel or from a HeightMap.
+*/
+
+#ifndef _TERRAIN_H
+#define _TERRAIN_H
+
+#include "world_entity.h"
+
+// FORWARD DEFINITION \\
+
+//! A simple method to call a desired debug world.
+enum DebugTerrain {TERRAIN_DAVE, TERRAIN_BENSCH};
+
+
+//! A Class to handle Terrain of orxonox
+class Terrain : public WorldEntity 
+{
+
+ public:
+  Terrain();
+  Terrain(char* fileName);
+  Terrain(DebugTerrain debugTerrain);
+  virtual ~Terrain();
+  void init();
+  
+  void buildDebugTerrain(DebugTerrain debugTerrain);
+  virtual void draw();
+
+ private:
+  int objectList;
+};
+
+#endif /* _TERRAIN_H */
Index: orxonox/branches/levelloader/src/world_entities/weapon.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/weapon.cc	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/weapon.cc	(revision 3605)
@@ -0,0 +1,220 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Patrick Boenzli
+   co-programmer: 
+*/
+
+
+#include "weapon.h"
+#include "stdincl.h"
+#include "world_entity.h"
+#include "vector.h"
+#include "objModel.h"
+#include "projectile.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+
+   creates a new weapon
+*/
+Weapon::Weapon () : WorldEntity()
+{}
+
+
+/**
+   \brief standard deconstructor
+*/
+Weapon::~Weapon () 
+{
+  // model will be deleted from WorldEntity-destructor
+}
+
+
+/** 
+    \brief enables the weapon
+
+    a weapon can be enabled/disabled because of various reasons. if a weapon is 
+    been enabled, it can interact in a world. elswhere it wont react to any
+    action.
+*/
+void Weapon::enable()
+{
+  this->enabled = true;
+}
+
+
+/** 
+    \brief disables the weapon
+
+    a weapon can be enabled/disabled because of various reasons. if a weapon is 
+    been enabled, it can interact in a world. elswhere it wont react to any
+    action.
+*/
+void Weapon::disable()
+{
+  this->enabled = false;
+}
+
+
+/** 
+    \brief checks if the weapon is enabled
+    \returns true if enabled
+
+    a weapon can be ebabled/disabled because of various reasons. if a weapon is 
+    been enabled, it can interact in a world. elswhere it wont react to any
+    action.
+*/
+bool Weapon::isEnabled()
+{
+  return this->enabled;
+}
+
+
+/**
+   \brief sets a new projectile to the weapon
+   \param new projectile for this weapon
+
+   weapon an projectile are independent, so you can combine them as you want
+*/
+void Weapon::setProjectile(Projectile* projectile)
+{
+  this->projectile = projectile;
+}
+
+
+/**
+   \brief sets a new projectile to the weapon
+   \returns the current projectile of this weapon
+
+   weapon an projectile are independent, so you can combine them as you want
+*/
+Projectile* Weapon::getProjectile()
+{
+  return this->projectile;
+}
+
+
+/**
+   \brief this activates the weapon
+
+   This is needed, since there can be more than one weapon on a ship. the 
+   activation can be connected with an animation. for example the weapon is 
+   been armed out. 
+*/
+void Weapon::activate()
+{}
+
+
+/**
+   \brief this deactivates the weapon
+
+   This is needed, since there can be more than one weapon on a ship. the 
+   activation can be connected with an animation. for example the weapon is 
+   been armed out.
+*/
+void Weapon::deactivate()
+{}
+
+/**
+   \brief asks if the current weapon is active
+   \returns true if it the weapon is active
+*/
+bool Weapon::isActive()
+{}
+
+/**
+   \brief sets a weapon idle time
+   \param idle time in ms
+
+   a weapon idle time is the time spend after a shoot until the weapon can
+   shoot again
+*/
+void Weapon::setWeaponIdleTime(float time)
+{}
+
+/**
+   \brief gets the weapon idle time
+   \returns idle time in ms
+
+   a weapon idle time is the time spend after a shoot until the weapon can
+   shoot again
+*/
+float Weapon::getWeaponIdleTime(void)
+{}
+
+/**
+   \brief checks if the idle time is elapsed
+   \return true if time is elapsed
+
+   a weapon idle time is the time spend after a shoot until the weapon can
+   shoot again
+*/
+bool Weapon::hasWeaponIdleTimeElapsed(void)
+{}
+
+
+/**
+   \brief fires the weapon
+   
+   this is called from the player.cc, when fire-button is been pushed
+*/
+void Weapon::fire()
+{}
+
+
+/**
+   \brief is called, when the weapon gets hit (=collide with something)
+   \param from which entity it is been hit
+   \param where it is been hit
+
+   this may not be used, since it would make the game relay complicated when one
+   can destroy the weapons of enemies or vice versa.
+*/
+void Weapon::hit (WorldEntity* entity, Vector* position) 
+{}
+
+
+/**
+   \brief is called, when the weapon is destroyed
+
+   this is in conjunction with the hit function, so when a weapon is able to get
+   hit, it can also be destoryed.
+*/
+void Weapon::destroy () 
+{}
+
+
+/**
+   \brief tick signal for time dependent/driven stuff
+*/
+void Weapon::tick (float time) 
+{}
+
+
+/**
+   \brief is called, when there is no fire button pressed
+*/
+void Weapon::weaponIdle()
+{}
+
+
+/**
+   \brief this will draw the weapon
+*/
+void Weapon::draw () 
+{}
+
Index: orxonox/branches/levelloader/src/world_entities/weapon.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/weapon.h	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/weapon.h	(revision 3605)
@@ -0,0 +1,81 @@
+/*! 
+    \file weapon.h
+    \brief a weapon that a player can use
+
+    A Player has a list of weapons, that can be choosen to shoot projectiles
+    (projectiles.{cc,h}) at ennemies. These weapons can be shooted sequentially
+    or (if able) combined. Therefore you can choose the weapon mode = choose
+    a weapon.
+
+    A weapon is characterized by:
+     o firing-rate: the initial firing rate of a weapon (1/s = Herz)
+     o slowdown-factor: this is a factor d: exp(-d*x), d is element of all positive R. it determines how fast the firing-rate will slow down. if no slowdown: d=0, the bigger d is, the faster the weapon will slow down!
+     o energy-consumption: this determines the energy that has to be used to produce this projectile = costs per projectile
+    
+    Furthermore there are some other attributes, that will help to represent a firing
+    weapon in this world:
+     o sound file/ressource: this is a pointer to the sound-file/ressource. however it may be represented
+     o shooting animation
+     
+*/
+
+
+#ifndef _WEAPON_H
+#define _WEAPON_H
+
+#include "world_entity.h"
+
+class Projectile;
+
+typedef enum {
+  SHOOT,
+  EMPTY,
+  RELOAD,
+  SPECIAL1,
+  SPECIAL2,
+  SPECIAL3
+} weaponSoundType;
+
+
+class Weapon : public WorldEntity 
+{
+  friend class World;
+
+ public:
+  Weapon ();
+  virtual ~Weapon ();
+  
+  void enable(void);
+  void disable(void);
+  bool isEnabled(void);
+
+  void setProjectile(Projectile* projectile);
+  Projectile* getProjectile(void);
+
+  virtual void activate(void);
+  virtual void deactivate(void);
+  bool isActive(void);
+
+  virtual void setWeaponIdleTime(float time);
+  virtual float getWeaponIdleTime(void);
+  virtual bool hasWeaponIdleTimeElapsed(void);
+
+  virtual void fire(void);
+  virtual void hit (WorldEntity* weapon, Vector* loc);
+  virtual void destroy(void);
+  
+  virtual void tick(float time);
+  virtual void weaponIdle(void);
+  virtual void draw(void);
+
+
+ private:
+  bool enabled;
+  float localTime;
+  float slowDownFactor;
+  Projectile* projectile;
+  //WeaponSound sound;
+
+};
+
+#endif /* _WEAPON_H */
Index: orxonox/branches/levelloader/src/world_entities/world_entity.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/world_entity.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/world_entity.cc	(revision 3605)
@@ -38,4 +38,5 @@
   this->setClassName ("WorldEntity");
   this->bDraw = true;
+  this->model = NULL;
   //  collisioncluster = NULL;
 }
@@ -47,27 +48,25 @@
 {
   // if( collisioncluster != NULL) delete collisioncluster;
+  delete this->model;
 }
 
 /**
-   \brief get the Location of the WorldEntity
-   \return a pointer to location
+   \brief sets the character attributes of a worldentity
+   \param character attributes
+
+   these attributes don't have to be set, only use them, if you need them
 */
-/*PN
-Location* WorldEntity::getLocation ()
-{
-  return &loc;
-}
-*/
+void WorldEntity::setCharacterAttributes(CharacterAttributes* charAttr)
+{}
+
 
 /**
-   \brief get the Placement of the WorldEntity
-   \return a pointer to placement
+   \brief gets the Character attributes of this worldentity
+   \returns character attributes
 */
- /*PN
-Placement* WorldEntity::getPlacement ()
-{
-  return &place;
-}
- */
+CharacterAttributes* WorldEntity::getCharacterAttributes()
+{}
+
+
 /**
    \brief query whether the WorldEntity in question is free
@@ -93,14 +92,4 @@
 }
 */
-
-/**
-   \brief this method is called every frame
-   \param time: the time in seconds that has passed since the last tick
-   
-   Handle all stuff that should update with time inside this method (movement, animation, etc.)
-*/
-void WorldEntity::tick(float time) 
-{
-}
 
 
@@ -130,12 +119,4 @@
 
 /**
-   \brief the entity is drawn onto the screen with this function
-   
-   This is a central function of an entity: call it to let the entity painted to the screen. Just override this function with whatever you want to be drawn.
-*/
-void WorldEntity::draw() 
-{}
-
-/**
    \brief this function is called, when two entities collide
    \param other: the world entity with whom it collides
@@ -147,4 +128,5 @@
 void WorldEntity::collide(WorldEntity* other, Uint32 ownhitflags, Uint32 otherhitflags) {}
 
+
 /**
    \brief this function is called, when the ship is hit by a waepon
@@ -154,12 +136,5 @@
    calculate the damage depending
 */
-void WorldEntity::hit(WorldEntity* weapon, Vector loc) {}
-
-/**
-   \brief this function is called when the entity is to be destroied
-   
-   This can be called, if eg. something realy bad happens :)
-*/
-void WorldEntity::destroy() {}
+void WorldEntity::hit(WorldEntity* weapon, Vector* loc) {}
 
 
@@ -174,4 +149,36 @@
 }
 
+
+/**
+   \brief this method is called by the world if the WorldEntity leaves valid gamespace
+   
+   For free entities this means it left the Track boundaries. With bound entities it means its Location adresses a
+   place that is not in the world anymore. In both cases you might have to take extreme measures (a.k.a. call destroy).
+*/
+void WorldEntity::leftWorld ()
+{
+}
+
+
+/**
+   \brief this method is called every frame
+   \param time: the time in seconds that has passed since the last tick
+   
+   Handle all stuff that should update with time inside this method (movement, animation, etc.)
+*/
+void WorldEntity::tick(float time) 
+{
+}
+
+
+/**
+   \brief the entity is drawn onto the screen with this function
+   
+   This is a central function of an entity: call it to let the entity painted to the screen. Just override this function with whatever you want to be drawn.
+*/
+void WorldEntity::draw() 
+{}
+
+
 /**
    \brief this handles incoming command messages
@@ -184,25 +191,2 @@
 {
 }
-
-/**
-   \brief this is called by the local Camera to determine the point it should look at on the WorldEntity
-   \param locbuf: a pointer to the buffer to fill with a location to look at
-	
-   You may put any Location you want into locbuf, the Camera will determine via the corresponding Track how
-   to look at the location you return with this.
-*/
-/*PN
-void WorldEntity::getLookat (Location* locbuf)
-{
-}
-*/
-
-/**
-   \brief this method is called by the world if the WorldEntity leaves valid gamespace
-   
-   For free entities this means it left the Track boundaries. With bound entities it means its Location adresses a
-   place that is not in the world anymore. In both cases you might have to take extreme measures (a.k.a. call destroy).
-*/
-void WorldEntity::leftWorld ()
-{
-}
Index: orxonox/branches/levelloader/src/world_entities/world_entity.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/world_entity.h	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/world_entity.h	(revision 3605)
@@ -9,7 +9,9 @@
 #include "stdincl.h"
 #include "p_node.h"
+#include "objModel.h"
 
 //class CollisionCluster;
-class OBJModel;
+class CharacterAttributes;
+
 
 //! Basic class from which all interactive stuff in the world is derived from
@@ -22,17 +24,20 @@
   virtual ~WorldEntity ();
 
-  OBJModel* model;                  //!< The model that should be loaded for this entity.
+
+
   
   //void setCollision (CollisionCluster* newhull);
   
-  bool isFree ();
-  
   //void addAbility(Ability* ability);
   //void removeAbility(Ability* ability);
-  
+  void setDrawable (bool bDraw);  
+  bool isFree ();
+  void setCharacterAttributes(CharacterAttributes* charAttr);
+  CharacterAttributes* getCharacterAttributes();
+
   virtual void postSpawn ();
-  virtual void tick (float time);
-  virtual void hit (WorldEntity* weapon, Vector loc);
-  virtual void destroy ();
+  virtual void leftWorld ();
+
+  virtual void hit (WorldEntity* weapon, Vector* loc);
   virtual void collide (WorldEntity* other,  Uint32 ownhitflags, Uint32 otherhitflags);
   virtual void command (Command* cmd);
@@ -40,7 +45,9 @@
   void processDraw ();
   virtual void draw ();
-  void setDrawable (bool bDraw);
+  virtual void tick (float time);
   
-  virtual void leftWorld ();
+ protected:
+  OBJModel* model;                  //!< The model that should be loaded for this entity.
+  CharacterAttributes* charAttr;      //!< the character attributes of a world_entity
   
  private:
@@ -49,4 +56,6 @@
   bool bDraw;                         //!< If it should be visible.
 
+
+
   //CollisionCluster* collisioncluster; //!< The collision-Cluster of this entity.
 };
